//ttf(ttedit-all-unicode)s -> ttc
//  ver.0.01   (c)Beer  2003.4.3
#include	<Be.h>

#define	MAX_TTF_FILES	8

void	prepare_dir();	//(delete GSUB,mort)
void	merge_glyf();	//loca,glyf,hmtx,vmtx
void	remake_cmap();	//cmap
void	update_tbl();	//head,hhea,vhea,maxp
void	copy_tbl();		//OS/2,cvt ,fpgm,gasp,name,post,prep
void	write_dir();	//table_directory,total_sum(head)

uint32	set_tbl(uchar n,uint32 tblname,uchar *dt,uint32 len);
uchar*	search_newtbl(uchar n,uint32 tblname);
int		search_tbl(uint32 tblname,uchar *s);
uint32	sumB32(uint32 *p,int len);
void	quit(char *p);

uchar	rbuf[12*1024*1024];	//12MBytes
uchar	wbuf[32*1024*1024];	//32MBytes
char	ifc,ifn[MAX_TTF_FILES][256],ofn[256];
FILE	*tfp,*ifp,*ofp;
uint32	wpos;

uint16	rgc[MAX_TTF_FILES],wgc;			//count of glyf
uint16	locno[MAX_TTF_FILES][65536];	//old_loc->new_loc
uchar	glff[MAX_TTF_FILES][65536];		//glyf_flag   0.space 1.character

uchar	*tdir,*loca,*glyf;
uchar	*cmap,*hmtx,*vmtx;
uint32	dirl;

main(int ac,char **ag)
{
	if(ac<2)quit("arg error\nusage: ttf2ttc ttf_file1 [ttf_file2] [ttf_file3]..[ttf_file8]\n");
	ifc=ac-1;
	for(int i=0;i<ifc;i++)strcpy(ifn[i],ag[i+1]);
	if(ifc==1)sprintf(ofn,"new.ttf");else sprintf(ofn,"new.ttc");

	if((ofp=fopen(ofn,"wb"))==NULL)quit("cannot output");
	wpos=0;

	tdir=wbuf;				//(0000000-000ffff)64kB
	prepare_dir();

	loca=wbuf+0x40000;		//(0040000-007ffff)256kB
	hmtx=wbuf+0x80000;		//(0080000-00bffff)256kB
	vmtx=wbuf+0xc0000;		//(00c0000-00fffff)256kB
	glyf=wbuf+0x100000;		//(0100000-1ffffff)31MB
	merge_glyf();	//read loca,glyf  >>>  write loca,glyf

	cmap=wbuf+0x100000;		//(0100000-)
	remake_cmap();

	update_tbl();
	copy_tbl();
	write_dir();

	fclose(ofp);
	quit("");
}



void prepare_dir()
{
	*(uint32*)(tdir+0)=B_HOST_TO_BENDIAN_INT32('ttcf');
	*(uint32*)(tdir+4)=B_HOST_TO_BENDIAN_INT32(0x00010000);
	*(uint32*)(tdir+8)=B_HOST_TO_BENDIAN_INT32(ifc);
	uchar	*dp=tdir+12+ifc*4;
	for(int i=0;i<ifc;i++){
printf("prepare ttf_no=%d\n",i);
		*(uint32*)(tdir+12+i*4)=B_HOST_TO_BENDIAN_INT32(dp-tdir);
		if((ifp=fopen(ifn[i],"rb"))==NULL)quit("cannot open ttf-file");
		fseek(ifp,0,0);
		fread(dp,1,12,ifp);
		uchar	*tcp=dp+5;
		int	tbls=*tcp;
		dp+=12;
printf("tbls=%d\n",tbls);
		for(int	j=0;j<tbls;j++){
			fread(dp,1,16,ifp);
			uint32	tn=B_BENDIAN_TO_HOST_INT32(*(uint32*)dp);
			if((tn=='GSUB')||(tn=='mort')){
				(*tcp)--;
			}else{
				dp+=16;
			}
		}
		fclose(ifp);
	}
	dirl=dp-tdir;
	//toriaezu//
	if(ifc==1)wpos+=fwrite(tdir+16,1,dirl-16,ofp);else wpos+=fwrite(tdir,1,dirl,ofp);
}

void merge_glyf()
{
	uchar	s[16];
	wgc=0;
	*(uint32*)loca=0;
	for(int i=0;i<ifc;i++){
printf("merge_glyf ttf_no=%d\n",i);
		if((ifp=fopen(ifn[i],"rb"))==NULL)quit("cannot open ttf-file");
		uchar	*lp,*gp,*hp,*vp;
		uint32	ll,gl,hl,vl;
		if(search_tbl('loca',s))quit("table(loca) is not found");
		lp=rbuf;ll=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
		fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
		fread(lp,1,ll,ifp);
		if(search_tbl('glyf',s))quit("table(glyf) is not found");
		gp=rbuf+ll;gl=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
		fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
		fread(gp,1,gl,ifp);
		if(search_tbl('hmtx',s))quit("table(hmtx) is not found");
		hp=rbuf+ll+gl;hl=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
		fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
		fread(hp,1,hl,ifp);
		if(search_tbl('vmtx',s))quit("table(vmtx) is not found");
		vp=rbuf+ll+gl+hl;vl=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
		fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
		fread(vp,1,vl,ifp);
		for(int j=0;j<65536;j++)locno[i][j]=0;

		rgc[i]=ll/4-1;	//glyf(read-ttf) count
		for(int ri=0;ri<rgc[i];ri++){
			uchar	*rp=gp+B_BENDIAN_TO_HOST_INT32(*(uint32*)lp);
			uint32	rl=B_BENDIAN_TO_HOST_INT32(*((uint32*)lp+1))-B_BENDIAN_TO_HOST_INT32(*(uint32*)lp);
			glff[i][ri]=rl?1:0;
			uint32	hm=*((uint32*)hp+ri);
			uint32	vm=*((uint32*)vp+ri);
			int	wi;
			for(wi=0;wi<wgc;wi++){
				uchar	*wp=glyf+B_BENDIAN_TO_HOST_INT32(*((uint32*)loca+wi));
				uint32	wl=B_BENDIAN_TO_HOST_INT32(*((uint32*)loca+wi+1))-B_BENDIAN_TO_HOST_INT32(*((uint32*)loca+wi));
				if(rl!=wl)continue;
				int	j;
				for(j=0;j<rl;j++)if(*(rp+j)!=*(wp+j))break;
				if((j==rl)&&(hm==*((uint32*)hmtx+wi))&&(vm==*((uint32*)vmtx+wi))){	//found same glyf
					locno[i][ri]=wi;
					break;
				}
			}
			if(wi==wgc){	//new glyf
				if(*rp&0x80){
					printf("not-supported CompositeGlyph\n [skip] glfno=%04x\n",i);
				}else{
					*((uint32*)hmtx+wgc)=hm;
					*((uint32*)vmtx+wgc)=vm;
					uchar	*wp=glyf+B_BENDIAN_TO_HOST_INT32(*((uint32*)loca+wgc));
					for(int j=0;j<rl;j++)*(wp++)=*(rp++);
					locno[i][ri]=wgc++;
					*((uint32*)loca+wgc)=B_HOST_TO_BENDIAN_INT32(wp-glyf);
				}
			}
			lp+=4;
		}
		fclose(ifp);
printf("glyfs=%04x\n",wgc);
	}
	uint32	len;
	for(int i=0;i<ifc;i++)len=set_tbl(i,'loca',loca,(wgc+1)*4);
	wpos+=fwrite(loca,1,len,ofp);
	for(int i=0;i<ifc;i++)len=set_tbl(i,'glyf',glyf,B_BENDIAN_TO_HOST_INT32(*((uint32*)loca+wgc)));
	wpos+=fwrite(glyf,1,len,ofp);
	for(int i=0;i<ifc;i++)len=set_tbl(i,'hmtx',hmtx,wgc*4);
	wpos+=fwrite(hmtx,1,len,ofp);
	for(int i=0;i<ifc;i++)len=set_tbl(i,'vmtx',vmtx,wgc*4);
	wpos+=fwrite(vmtx,1,len,ofp);
printf("merge_glyf end\n");
}

void remake_cmap()
{
	uchar	s[16];
	for(int i=0;i<ifc;i++){
printf("remake_cmap ttf_no=%d\n",i);
		if((ifp=fopen(ifn[i],"rb"))==NULL)quit("cannot open ttf-file");
		uchar	*cp;
		uint32	cl;
		if(search_tbl('cmap',s))quit("table(cmap) is not found");
		cp=rbuf;cl=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
		fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
		fread(cp,1,cl,ifp);
		fclose(ifp);

		int	tbc=cp[3];
		uchar	*cmp;
		int	j;
		for(j=0;j<tbc;j++){
			cmp=rbuf+B_BENDIAN_TO_HOST_INT32(*(uint32*)(cp+4+j*8+4));
			if(cmp[1]==4)break;	//cp=table_format4
		}
		if(j==tbc)quit("table(cmap) don't have format4");

		uint16	oldgno[65536];	//chr_code->gly_no
		for(int c=0;c<65536;c++)oldgno[c]=0;

		uint16	sc=B_BENDIAN_TO_HOST_INT16(*(uint16*)(cmp+6));	//segCountX2
		uint16	*ecp=(uint16*)(cmp+14);							//endCount[segCount]
		uint16	*scp=(uint16*)(cmp+sc+16);						//startCount[segCount]
		uint16	*idp=(uint16*)(cmp+sc*2+16);					//idDelta[segCount]
		uint16	*irp=(uint16*)(cmp+sc*3+16);					//idRangeOffset[segCount]
		uint16	*gap=(uint16*)(cmp+sc*4+16);					//glyphdArray[]

		for(j=0;j<sc/2;j++){
			if(irp[j]==0){
				for(int c=B_BENDIAN_TO_HOST_INT16(scp[j]);c<=B_BENDIAN_TO_HOST_INT16(ecp[j]);c++){
					uint16	cc=c+B_BENDIAN_TO_HOST_INT16(idp[j]);
					if((glff[i][cc]==0)&&(c!=0x0020)&&(c!=0x3000))cc=0;	//undefined chrs
					oldgno[c]=cc;
				}
			}else{
				printf("not-supported GlyphdArray\n [skip] chr=%04x-%04x delta=%04x offset=%04x\n",B_BENDIAN_TO_HOST_INT16(scp[j]),B_BENDIAN_TO_HOST_INT16(ecp[j]),B_BENDIAN_TO_HOST_INT16(idp[j]),B_BENDIAN_TO_HOST_INT16(irp[j]));//////oldgno[c]=gap[];
			}
		}

//create_cmap		
printf("create_cmap ttf_no=%d\n",i);
		cp=cmap;
		*(uint16*)(cp+0)=B_HOST_TO_BENDIAN_INT16(0);	//table_version
		*(uint16*)(cp+2)=B_HOST_TO_BENDIAN_INT16(1);	//number_of_tables
		cp+=4;
		cmp=cp+8;
		*(uint16*)(cp+0)=B_HOST_TO_BENDIAN_INT16(3);	//plathome_ID
		*(uint16*)(cp+2)=B_HOST_TO_BENDIAN_INT16(1);	//plathome_specific_encoding_ID
		*(uint32*)(cp+4)=B_HOST_TO_BENDIAN_INT32(cmp-cmap);	//offset

		uint16	sr,es;
		sc=1;sr=1;es=(uint16)-1;
		for(j=1;j<65536;j++)if((locno[i][oldgno[j]])&&((locno[i][oldgno[j]]-locno[i][oldgno[j-1]]!=1)||(locno[i][oldgno[j]]==1)))sc++;
printf("segcount=%04x\n",sc);
		if(sc>0x1ffc)quit("cmap_segcount is too big\n");
		while(sr<sc){sr<<=1;es++;}
		sc*=2;
		*(uint16*)(cmp+0)=B_HOST_TO_BENDIAN_INT16(4);		//format=4(Segment mapping)
		*(uint16*)(cmp+2)=B_HOST_TO_BENDIAN_INT16(sc*4+16);	//length
		*(uint16*)(cmp+4)=B_HOST_TO_BENDIAN_INT16(0);		//version
		*(uint16*)(cmp+6)=B_HOST_TO_BENDIAN_INT16(sc);		//segCountX2
		*(uint16*)(cmp+8)=B_HOST_TO_BENDIAN_INT16(sr);		//searchRange
		*(uint16*)(cmp+10)=B_HOST_TO_BENDIAN_INT16(es);		//entrySelector
		*(uint16*)(cmp+12)=B_HOST_TO_BENDIAN_INT16(sc-sr);	//rangeShift
		ecp=(uint16*)(cmp+14);					//endCount[segCount]
		*(uint16*)(cmp+14+sc)=B_HOST_TO_BENDIAN_INT16(0);	//reserved
		scp=(uint16*)(cmp+16+sc);				//startCount[segCount]
		idp=(uint16*)(cmp+16+sc*2);				//idDelta[segCount]
		irp=(uint16*)(cmp+16+sc*3);				//idRangeOffset[segCount]
//		*(uint16*)(cmp+16+sc*4)=B_HOST_TO_BENDIAN_INT16(0);	//(dummy)glyphIdArray[0]

		for(j=1;j<65536;j++){
			if(oldgno[j]==0)continue;
			*(scp++)=B_HOST_TO_BENDIAN_INT16(j);
			*(idp++)=B_HOST_TO_BENDIAN_INT16(locno[i][oldgno[j]]-j);
			*(irp++)=B_HOST_TO_BENDIAN_INT16(0);
			while(locno[i][oldgno[j+1]]-locno[i][oldgno[j]]==1)j++;
			*(ecp++)=B_HOST_TO_BENDIAN_INT16(j);
		}
		*(scp++)=B_HOST_TO_BENDIAN_INT16(0xffff);
		*(idp++)=B_HOST_TO_BENDIAN_INT16(1);
		*(irp++)=B_HOST_TO_BENDIAN_INT16(0);
		*(ecp++)=B_HOST_TO_BENDIAN_INT16(0xffff);

		uint32	len=(cmp-cmap)+(sc*4+16);
		len=set_tbl(i,'cmap',cmap,len);
		wpos+=fwrite(cmap,1,len,ofp);
	}
}

void update_tbl()
{
	uchar	s[16];
	uint32	len;
	for(int i=0;i<ifc;i++){
printf("update_tbl(separate) ttf_no=%d\n",i);
		if((ifp=fopen(ifn[i],"rb"))==NULL)quit("cannot open ttf-file");
//head
		if(search_tbl('head',s))quit("table(head) is not found");
		len=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
		fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
		fread(rbuf,1,len,ifp);
		fclose(ifp);
		*(uint32*)(rbuf+8)=0;								//checkSumAdjustment
		len=set_tbl(i,'head',rbuf,len);
		wpos+=fwrite(rbuf,1,len,ofp);
	}
printf("update_tbl(common)\n");
	if((ifp=fopen(ifn[0],"rb"))==NULL)quit("cannot open ttf-file");
//hhea
	if(search_tbl('hhea',s))quit("table(hhea) is not found");
	len=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
	fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
	fread(rbuf,1,len,ifp);
	*(uint16*)(rbuf+34)=B_HOST_TO_BENDIAN_INT16(wgc);		//numberOfHMetrics
	for(int i=0;i<ifc;i++){
		len=set_tbl(i,'hhea',rbuf,len);
	}
	wpos+=fwrite(rbuf,1,len,ofp);
//vhea
	if(search_tbl('vhea',s))quit("table(vhea) is not found");
	len=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
	fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
	fread(rbuf,1,len,ifp);
	*(uint16*)(rbuf+34)=B_HOST_TO_BENDIAN_INT16(wgc);		//numberOfHMetrics
	for(int i=0;i<ifc;i++){
		len=set_tbl(i,'vhea',rbuf,len);
	}
	wpos+=fwrite(rbuf,1,len,ofp);
	fclose(ifp);
//maxp
	for(int i=0;i<ifc;i++){
		if((ifp=fopen(ifn[i],"rb"))==NULL)quit("cannot open ttf-file");
		if(search_tbl('maxp',s))quit("table(maxp) is not found");
		len=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
		if(len!=32)quit("table(maxp) is unsupported version");
		fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
		fread(rbuf+i*len,1,len,ifp);
		fclose(ifp);
	}
	*(uint16*)(rbuf+4)=B_HOST_TO_BENDIAN_INT16(wgc);		//numGlyphs
	for(int j=0;j<13;j++){
		uint16	m=0;
		for(int i=0;i<ifc;i++){
			uint16	n=B_BENDIAN_TO_HOST_INT16(*((uint16*)(rbuf+i*32+6)+j));
			if(m<n)m=n;
		}
		*((uint16*)(rbuf+6)+j)=B_HOST_TO_BENDIAN_INT16(m);
	}
	for(int i=0;i<ifc;i++){
		len=set_tbl(i,'maxp',rbuf,len);
	}
	wpos+=fwrite(rbuf,1,len,ofp);
}

void copy_tbl()
{
	static uint32	stn[]={
		'OS/2','name','post',0
	};
	static uint32	ctn[]={
		'cvt ','fpgm','gasp','prep',0
	};
	uchar	s[16];
	for(int i=0;i<ifc;i++){
printf("copy_tbl(separate) ttf_no=%d\n",i);
		if((ifp=fopen(ifn[i],"rb"))==NULL)quit("cannot open ttf-file");
		for(int j=0;stn[j];j++){
			if(search_tbl(stn[j],s))continue;
			uint32	len=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
			fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
			fread(rbuf,1,len,ifp);
			len=set_tbl(i,stn[j],rbuf,len);
			wpos+=fwrite(rbuf,1,len,ofp);
		}
		fclose(ifp);
	}
printf("copy_tbl(common)\n");
	if((ifp=fopen(ifn[0],"rb"))==NULL)quit("cannot open ttf-file");
	for(int j=0;ctn[j];j++){
		if(search_tbl(ctn[j],s))continue;
		uint32	len=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
		fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
		fread(rbuf,1,len,ifp);
		for(int i=0;i<ifc;i++){
			len=set_tbl(i,ctn[j],rbuf,len);
		}
		wpos+=fwrite(rbuf,1,len,ofp);
	}
	fclose(ifp);
}

void write_dir()
{
	uchar	s[16];
	fseek(ofp,0,0);
	if(ifc==1)fwrite(tdir+16,1,dirl-16,ofp);else fwrite(tdir,1,dirl,ofp);
//total_sum(head)
//	uint32	sum0=sumB32((uint32*)tdir,12+ifc*4);	//ttc_header
	for(int i=0;i<ifc;i++){
		uchar	*p=tdir+B_BENDIAN_TO_HOST_INT32(*(uint32*)(tdir+12+i*4));
		uchar	tbls=p[5];
		uint32	sum=sumB32((uint32*)p,12+tbls*16);
		p+=12;
		for(int j=0;j<tbls;j++){
			sum+=B_BENDIAN_TO_HOST_INT32(*(uint32*)(p+j*16+4));
		}
printf("write_sum(head) ttf_no=%d\n",i);
		sum=B_HOST_TO_BENDIAN_INT32(0xb1b0afba-sum);
		p=search_newtbl(i,'head')+8;
		fseek(ofp,B_BENDIAN_TO_HOST_INT32(*(uint32*)p)+8,0);
		fwrite(&sum,4,1,ofp);
	}
}

uint32 set_tbl(uchar n,uint32 tblname,uchar *dt,uint32 len)
{
	while(len&3)dt[len++]=0;
	uint32	*p=(uint32*)search_newtbl(n,tblname);
	uint32	sum=sumB32((uint32*)dt,len);
	*(++p)=B_HOST_TO_BENDIAN_INT32(sum);	//sum
	*(++p)=B_HOST_TO_BENDIAN_INT32(wpos);	//offset
	*(++p)=B_HOST_TO_BENDIAN_INT32(len);	//length
	return(len);
}

uchar* search_newtbl(uchar n,uint32 tblname)
{
	uchar	*r=NULL;
	uchar	*p=tdir+B_BENDIAN_TO_HOST_INT32(*(uint32*)(tdir+12+n*4));
	int	tbls=p[5];
	p+=12;
	for(int i=0;i<tbls;i++){
		if(B_BENDIAN_TO_HOST_INT32(*(uint32*)p)==tblname){r=p;break;}
		p+=16;
	}
	return(r);
}

int search_tbl(uint32 tblname,uchar *s)
{
	int	r=1;
	fseek(ifp,0,0);
	fread(s,1,12,ifp);
	int	tbls=s[5];
	for(int i=0;i<tbls;i++){
		fread(s,1,16,ifp);
		if(B_BENDIAN_TO_HOST_INT32(*(uint32*)s)==tblname){r=0;break;}
	}
	return(r);
}

uint32 sumB32(uint32 *p,int len)
{
	uint32	sum=0;
	len=len/4;
	while(len--)sum+=B_BENDIAN_TO_HOST_INT32(*(p++));
	return(sum);
}

void quit(char *p)
{
	if(*p)printf("error : %s\n",p);
	else printf("complete\n");
	exit(0);
}
